/* Headers utilizados */
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <errno.h>

/* Variveis */
extern errno;
int hd;
char comando[200];
int escritos;
int tam_cmd;
char resposta[100], retorno[3];
char *ptr;
int lidos;
int ret, sair, i, erro;


/******************************************************/
/*** Funcao generica para leitura do retorno do ECF ***/
/******************************************************/
void LeRetorno(char cmd, int secao)
{
 /* Monta comando cmd para o dd, solicitando a secao [secao] do FiscNET */
 comando[0] = '\2';		/* CTRL-B */
 comando[1] = cmd;		/*  Comando  */
 comando[2] = '\xd';		/* CR */
 comando[3] = '\xa';		/* LF */
 comando[4] = '\0';

 erro = 0;
 sair = 0;
 ret = 2;		/* Assume retorno nao_pronto */
 do {

 	/* Escreve o comando no dispositivo */
	escritos = write(hd,comando,strlen(comando));

	/* Retorno esta disponivel? */
	lidos = read(hd, resposta, 100);
	resposta[lidos] = '\0';
	if (lidos) {
		for (ptr = resposta; *ptr && *ptr != cmd; ptr++) ;
		ptr++;
		retorno[0] = *ptr++;
		retorno[1] = *ptr;
		retorno[2] = '\0';

		ret = atoi(retorno);
		switch (ret) {
			case 0:	/* Recebeu resposta do DD */
				sair = 1;
				break;
			case 4:	/* Fora de Linha */
				printf("Impres. fora de linha!\n");
				sair = erro = 1;
				break;
			case 5:	/* Comando nao implementado */
				printf("Comando nao implementado!\n");
				sair = erro = 1;
				break;
			case 6:	/* Erro de sintaxe no comando */
				printf("Erro de sintaxe no comando enviado ao dd!\n");
				sair = erro = 1;
				break;
			default:	/* Nao pronto */
				/* Somente espera */
				break;
		} /* switch */

	}
	else {
		printf("Nao conseguiu ler do dispositivo FISCNET0.\n");
		sair = 1;
		erro = 1;
	}
 }while(ret == 2 && !sair);

 if (!erro) {
	for (*resposta = '\0', i = 0; i < 100; i++) resposta[i] = '\0';
	read(hd,resposta,100);
	printf("Retorno FiscNET secao %d => %s\n", secao, resposta);
 }
}

/************************/
/*** Modulo principal ***/
/************************/
void main(void) {

 /* Acesso ao device driver */
 hd = open("FISCNET0", O_RDWR);  /* Abre para escrita e leitura */
 if (hd == -1) {
	printf("Erro na abertura do device driver FISCNET0!\n");
	printf("Codigo do erro [%d]\n", errno);
	exit(1);
 } /* if*/

 /* Solicita ao dispositivo a transmisso do comando 'VendaItem'*/
 comando[0] = '\2';		/* InicioCmdDD - STX */
 comando[1] = '@';		/* ComandoDD - @	 */
 comando[2] = '\xd';	/* CR */
 comando[3] = '\xa';	/* LF */
 comando[4] = '\0';

 /* Monta o <ParametrosDD> */
 /* Primeiramente, monta o valor obrigatorio ; */
 strcat(comando,";");	/* Monta o caracter ; */

 /* Monta as secoes 2 e 3 do Protocolo FiscNET */
 strcat(comando,"VendeItem");		/* Monta o comando FiscNET */
 strcat(comando,";");				/* Monta o caracter obrigatrio ; */

 /* Inicio da montagem dos parametros do comando FiscNET */
 strcat(comando,"CodAliquota=-2 "); 			/* Situacao Tributaria */
 strcat(comando,"CodProduto=\"7891000123456\" ");	/* Codigo do Produto */
 strcat(comando,"NomeProduto=\"BISC VITAMINADO\" ");	/* Nome Produto */
 strcat(comando,"PrecoUnitario=1,50 ");		/* Valor Unitario */
 strcat(comando,"Quantidade=3 ");			/* Quantidade */
 strcat(comando,"Unidade=\"Un\"");			/* Unidade */

 /* Para testar o comando abaixo, deve-se comentar os 8 ultimos comandos strcat! */
 /*strcat(comando,"LeAliquota;CodAliquotaProgramavel=0");*/

 /* Finaliza o comando com <CR><LF> */
 tam_cmd = strlen(comando);
 comando[tam_cmd++] = '\xd';
 comando[tam_cmd++] = '\xa';
 comando[tam_cmd] = '\0';

 /* Escreve comando no dispositivo FISCNET0, ... */
 /* ...indicando que deve ser enviado o comando FiscNET VendeItem */
 escritos = write(hd,comando,strlen(comando));

 /* Retorno da Transmissao do Comando '@': foi enviado ou nao? */
 *resposta = '\0';
 lidos = read(hd,resposta,50);
 if (lidos) {
	for (ptr = resposta; *ptr && *ptr != '@'; ptr++) ;

	ptr++;
	retorno[0] = *ptr++;
	retorno[1] = *ptr;
	retorno[2] = '\0';

	if (strcmp(retorno,"00"))	/* Caso nao seja "00" */
		printf("Erro [%s] ao enviar comando 'VendaItem'!\n", retorno);
	else
		printf("Comando enviado ao equipamento fiscal...\n");
 }
 else
	printf("Nao conseguiu ler do dispositivo FISCNET0.\n");


 /* Obtem resposta do equipamento fiscal */
 LeRetorno('A', 2);
 LeRetorno('E', 3);

 close( hd );
} /* main */